package sun.swing;

import javax.swing.KeyStroke;
import javax.swing.JComponent;
import javax.swing.UIDefaults;
import javax.swing.TransferHandler;
import java.awt.Point;
import javax.swing.RepaintManager;
import javax.swing.text.JTextComponent;
import sun.misc.Unsafe;

public final class SwingAccessor
{
    private static final Unsafe unsafe;
    private static SwingAccessor.JTextComponentAccessor jtextComponentAccessor;
    private static SwingAccessor.JLightweightFrameAccessor jLightweightFrameAccessor;
    private static SwingAccessor.RepaintManagerAccessor repaintManagerAccessor;
    
    private SwingAccessor() {
    }
    
    public static void setJTextComponentAccessor(SwingAccessor.JTextComponentAccessor jtextComponentAccessor) {
        SwingAccessor.jtextComponentAccessor = jtextComponentAccessor;
    }
    
    public static SwingAccessor.JTextComponentAccessor getJTextComponentAccessor() {
        if (SwingAccessor.jtextComponentAccessor == null) {
            SwingAccessor.unsafe.ensureClassInitialized(JTextComponent.class);
        }
        return SwingAccessor.jtextComponentAccessor;
    }
    
    public static void setJLightweightFrameAccessor(SwingAccessor.JLightweightFrameAccessor jLightweightFrameAccessor) {
        SwingAccessor.jLightweightFrameAccessor = jLightweightFrameAccessor;
    }
    
    public static SwingAccessor.JLightweightFrameAccessor getJLightweightFrameAccessor() {
        if (SwingAccessor.jLightweightFrameAccessor == null) {
            SwingAccessor.unsafe.ensureClassInitialized(JLightweightFrame.class);
        }
        return SwingAccessor.jLightweightFrameAccessor;
    }
    
    public static void setRepaintManagerAccessor(SwingAccessor.RepaintManagerAccessor repaintManagerAccessor) {
        SwingAccessor.repaintManagerAccessor = repaintManagerAccessor;
    }
    
    public static SwingAccessor.RepaintManagerAccessor getRepaintManagerAccessor() {
        if (SwingAccessor.repaintManagerAccessor == null) {
            SwingAccessor.unsafe.ensureClassInitialized(RepaintManager.class);
        }
        return SwingAccessor.repaintManagerAccessor;
    }
    
    static {
        unsafe = Unsafe.getUnsafe();
    }
    
    public interface JLightweightFrameAccessor
    {
        public abstract void updateCursor(JLightweightFrame p0);
    }
    
    public interface JTextComponentAccessor
    {
        public abstract TransferHandler.DropLocation dropLocationForPoint(JTextComponent p0, Point p1);
        
        public abstract Object setDropLocation(JTextComponent p0, TransferHandler.DropLocation p1, Object p2, boolean p3);
    }
    
    public interface RepaintManagerAccessor
    {
        public abstract void addRepaintListener(RepaintManager p0, SwingUtilities2.RepaintListener p1);
        
        public abstract void removeRepaintListener(RepaintManager p0, SwingUtilities2.RepaintListener p1);
    }
    
    public interface UIDefaultsAccessor
    {
        public abstract void addInternalBundle(UIDefaults p0, String p1);
    }
    
    public interface JComponentAccessor
    {
        public abstract boolean getFlag(JComponent p0, int p1);
        
        public abstract void compWriteObjectNotify(JComponent p0);
    }
    
    public interface KeyStrokeAccessor
    {
        public abstract KeyStroke create();
    }
}
